import java.util.*;

/**
 * To represent an implementation of the three classical
 * graph traversal algorithms: 
 * Breadth-First Search, Depth-First Search
 * and Shortest Path.
 */
class GraphAlgorithms<T extends Node>{
    Graph<T> graphData;
    Path path;
    ToDo todolist;
  
    GraphAlgorithms(Graph<T> graphData){
        this.graphData = graphData;
    }

    /**
     * Produce the path from the given origin
     * to the given destination, using the given initialized
     * 'to do' list
     * @param origin the given origin
     * @param destination the given destination
     * @param todolist the 'to do' list for this algorithm
     */
    ArrayList<FromTo> runAlgo(String origin, String destination, ToDo todolist){
        this.todolist = todolist;
        this.path = new Path();
        todolist.add(new FromTo("", origin, 0), this.path);
        return this.buildPath(destination);
    }
  
    /**
     * INSERT HERE ANY CODE NEEDED TO IMPLEMENT THE THREE ALGORITHMS
     */
    ArrayList<FromTo> buildPath(String destination){
        throw new RuntimeException("you should implement this");
    }
  
    /**
     * Produce the route in this graph 
     * from the given origin to the given destination
     * using the BREADTH-FIRST SEARCH algorithm.
     * @param origin the given origin
     * @param destination the given destination
     * @return an <code>ArrayList</code> of <code>FromTo</code>
     * edges that represent the route
     */
    ArrayList<FromTo> findRouteBFS(String origin, String destination){
        return this.runAlgo(origin, destination, new ToDoQueue());
    }

    /**
     * Produce the route in this graph 
     * from the given origin to the given destination
     * using the DEPTH-FIRST SEARCH algorithm.
     * @param origin the given origin
     * @param destination the given destination
     * @return an <code>ArrayList</code> of <code>FromTo</code>
     * edges that represent the route
     */
    ArrayList<FromTo> findRouteDFS(String origin, String destination){
        return this.runAlgo(origin, destination, new ToDoStack());
    }

    /**
     * Produce the route in this graph 
     * from the given origin to the given destination
     * using the SHORTEST PATH algorithm.
     * @param origin the given origin
     * @param destination the given destination
     * @return an <code>ArrayList</code> of <code>FromTo</code>
     * edges that represent the route
     */
    ArrayList<FromTo> findRouteSPS(String origin, String destination){
        return this.runAlgo(origin, destination, new ToDoPriorityQueue());
    }
}
