import java.util.ArrayList;

/** To represent a node in a directed graph 
 *  with distances between nodes.
 * @author Viera K. Proulx
 * @since 28 March 2011
 */
public interface Node{
    /** Produce the label for this node
     * @return the name of this node */
    public String getLabel();
  
    /** Produce the list of labels for the neighbors of this node
     * @return the names of the neighboring nodes */
    public ArrayList<String> neighbors();
  
    /** Compute the distance from this node to the given one
     * @param that the given node
     * @return the distance between these two nodes */
    public double distanceTo(Node that);
}
