import java.util.*;

/**
 * To represent the map of the US 48 states
 * @author Viera K. Proulx
 * @ since 20 March 2011
 */
class USmap extends Graph<State>{
    /**
     * Build the <code>HashMap</code> representation of the map 
     * of the 48 US states
     */
    public USmap(){
        super();
        initMap(states.iterator());
    }
  
    /** the list of all states and cities and neighbors */
    public ArrayList<State> states = new ArrayList<State>(Arrays.asList(
    new State("AL", 
        new City("36105", "Montgomery", "AL", 86, 32),
        new ArrayList<String>(Arrays.asList("MS", "TN", "GA", "FL"))),
    
    new State("AZ",
        new City("85009", "Phoenix", "AZ", 112, 33),
        new ArrayList<String>(Arrays.asList("CA", "NV", "UT", "CO", "NM"))),
     
    new State("AR",
        new City("72201", "Little Rock", "AR", 92, 35),
        new ArrayList<String>(Arrays.asList("LA", "TX", "OK", "MO", "TN", "MS"))),
    
    new State("CA",
        new City("95819", "Sacramento", "CA", 121, 39),
        new ArrayList<String>(Arrays.asList("AZ", "NV", "OR"))),
    
    new State("CO",
        new City("80204", "Denver", "CO", 105, 40),
        new ArrayList<String>(Arrays.asList("AZ", "UT", "WY", "NE", "KS", "OK", "NM"))),
    
    new State("CT",
        new City("06120", "Hartford", "CT", 73, 42),
        new ArrayList<String>(Arrays.asList("NY", "MA", "RI"))),
    
    new State("DE",
        new City("19901", "Dover", "DE", 76, 40),
        new ArrayList<String>(Arrays.asList("MD", "PA", "NJ"))),
    
    new State("FL",
        new City("32304", "Tallahassee", "FL", 84, 30),
        new ArrayList<String>(Arrays.asList("AL", "GA"))),
    
    new State("GA",
        new City("30306", "Atlanta", "GA", 84, 34),
        new ArrayList<String>(Arrays.asList("FL", "AL", "TN", "NC", "SC"))),
    
    new State("IA",
        new City("50314", "Des Moines", "IA", 94, 41),
        new ArrayList<String>(Arrays.asList("IL", "MO", "NE", "SD", "MN", "WI"))),
    
    new State("ID",
        new City("83705", "Boise", "ID", 116, 44),
        new ArrayList<String>(Arrays.asList("NV", "OR", "WA", "MT", "WY", "UT"))),
    
    new State("IL",
        new City("62701", "Springfield", "IL", 90, 40),
        new ArrayList<String>(Arrays.asList("IN", "KY", "MO", "IA", "WI"))),
    
    new State("IN",
        new City("46219", "Indianapolis", "IN", 86, 40),
        new ArrayList<String>(Arrays.asList("MI", "OH", "KY", "IL"))),
    
    new State("KS",
        new City("66610", "Topeka", "KS", 96, 39),
        new ArrayList<String>(Arrays.asList("MO", "OK", "CO", "NE"))),
    
    new State("KY",
        new City("40212", "Frankfort", "KY", 86, 38),
        new ArrayList<String>(Arrays.asList("WV", "VA", "TN", "MO", "IL", "IN", "OH"))),
    
    new State("LA",
        new City("70815", "Baton Rouge", "LA", 91, 30),
        new ArrayList<String>(Arrays.asList("TX", "OK", "AR", "MS"))),
    
    new State("MA",
        new City("02115", "Boston", "MA", 71, 42),
        new ArrayList<String>(Arrays.asList("NY", "VT", "NH", "RI", "CT"))),
    
    new State("MD",
        new City("21403", "Annapolis", "MD", 76, 39),
        new ArrayList<String>(Arrays.asList("DE", "PA", "VA"))),
    
    new State("ME",
        new City("04330", "Augusta", "ME", 70, 44),
        new ArrayList<String>(Arrays.asList("NH"))),
    
    new State("MI",
        new City("48823", "Lansing", "MI", 84, 43),
        new ArrayList<String>(Arrays.asList("OH", "IN"))),
    
    new State("MN",
        new City("55103", "Saint Paul", "MN", 93, 45),
        new ArrayList<String>(Arrays.asList("WI", "IA", "SD", "ND"))),
    
    new State("MO",
        new City("65101", "Jefferson City", "MO", 92, 39),
        new ArrayList<String>(Arrays.asList("IL", "KY", "TN", "AR", "OK", "KS", "NE", "IA"))),
    
    new State("MS",
        new City("39209", "Jackson", "MS", 90, 32),
        new ArrayList<String>(Arrays.asList("AL", "LA", "AR", "TN"))),
    
    new State("MT",
        new City("59635", "Helena", "MT", 112, 47),
        new ArrayList<String>(Arrays.asList("ND", "SD", "WY", "ID"))),
    
    new State("NC",
        new City("27606", "Raleigh", "NC", 79, 36),
        new ArrayList<String>(Arrays.asList("VA", "TN", "GA", "SC"))),
    
    new State("ND",
        new City("58501", "Bismarck", "ND", 101, 47),
        new ArrayList<String>(Arrays.asList("MN", "SD", "MT"))),
    
    new State("NE",
        new City("68503", "Lincoln", "NE", 97, 41),
        new ArrayList<String>(Arrays.asList("IA", "MO", "KS", "CO", "WY", "SD"))),
    
    new State("NH",
        new City("03301", "Concord", "NH", 72, 43),
        new ArrayList<String>(Arrays.asList("ME", "MA", "VT"))),
    
    new State("NJ",
        new City("08618", "Trenton", "NJ", 75, 40),
        new ArrayList<String>(Arrays.asList("DE", "PA", "NY"))),
    
    new State("NM",
        new City("87505", "Santa Fe", "NM", 106, 36),
        new ArrayList<String>(Arrays.asList("AZ", "UT", "CO", "OK", "TX"))),
    
    new State("NV",
        new City("89704", "Carson City", "NV", 120, 39),
        new ArrayList<String>(Arrays.asList("CA", "OR", "ID", "UT", "AZ"))),
    
    new State("NY",
        new City("12207", "Albany", "NY", 74, 43),
        new ArrayList<String>(Arrays.asList("VT", "MA", "CT", "NJ", "PA"))),
    
    new State("OH",
        new City("43210", "Columbus", "OH", 83, 40),
        new ArrayList<String>(Arrays.asList("PA", "WV", "KY", "IN", "MI"))),
    
    new State("OK",
        new City("73105", "Oklahoma City", "OK", 98, 36),
        new ArrayList<String>(Arrays.asList("AR", "TX", "NM", "CO", "KS", "MO"))),
    
    new State("OR",
        new City("97301", "Salem", "OR", 123, 45),
        new ArrayList<String>(Arrays.asList("WA", "ID", "NV", "CA"))),
    
    new State("PA",
        new City("17101", "Harrisburg", "PA", 77, 40),
        new ArrayList<String>(Arrays.asList("NY", "NJ", "DE", "MD", "VA", "WV", "OH"))),
    
    new State("RI",
        new City("02908", "Providence", "RI", 71, 41),
        new ArrayList<String>(Arrays.asList("MA", "CT"))),
    
    new State("SC",
        new City("29209", "Columbia", "SC", 81, 34),
        new ArrayList<String>(Arrays.asList("NC", "GA"))),
    
    new State("SD",
        new City("57501", "Pierre", "SD", 100, 44),
        new ArrayList<String>(Arrays.asList("MN", "IA", "NE", "WY", "MT", "ND"))),
    
    new State("TN",
        new City("37914", "Nashville", "TN", 84, 36),
        new ArrayList<String>(Arrays.asList("NC", "GA", "AL", "MS", "AR", "MO", "KY"))),
    
    new State("TX",
        new City("78721", "Austin", "TX", 98, 30),
        new ArrayList<String>(Arrays.asList("NM", "OK", "AR", "LA"))),
    
    new State("UT",
        new City("84103", "Salt Lake City", "UT", 112, 41),
        new ArrayList<String>(Arrays.asList("CO", "NM", "AZ", "NV", "ID", "WY"))),
    
    new State("VA",
        new City("23222", "Richmond", "VA", 77, 38),
        new ArrayList<String>(Arrays.asList("MD", "PA", "WV", "KY", "TN", "NC"))),
    
    new State("VT",
        new City("05602", "Montpelier", "VT", 73, 44),
        new ArrayList<String>(Arrays.asList("NY", "NH", "MA"))),
    
    new State("WA",
        new City("98501", "Olympia", "WA", 123, 47),
        new ArrayList<String>(Arrays.asList("ID", "OR"))),
    
    new State("WI",
        new City("53714", "Madison", "WI", 89, 43),
        new ArrayList<String>(Arrays.asList("IL", "IA", "MN"))),
    
    new State("WV",
        new City("25301", "Charleston", "WV", 82, 38),
        new ArrayList<String>(Arrays.asList("PA", "VA", "KY", "OH"))),
    
    new State("WY",
        new City("82001", "Cheyenne", "WY", 105, 41),
        new ArrayList<String>(Arrays.asList("SD", "NE", "CO", "UT", "ID", "MT")))));
}
